' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class BigE_MK3 extends Vehicle
    sys as VehicleSystemObject
    
    LargeEngine1 as LargeEngine
    Steering1 as Steering
    LootCarrier1 as LootCarrier
    LongRangeRadar1 as LongRangeRadar
    WaypointSensor1 as WaypointSensor
    Divide1 as Divide
    ModeSwitch1 as ModeSwitch
    WrapVar1 as WrapVar
    Add1 as Add
    TickTimer1 as TickTimer
    Variable2 as Variable
    Compare1 as Compare
    Variable1 as Variable
    Variable3 as Variable
    TickTimer2 as TickTimer
    RangeTest1 as RangeTest
    Startup1 as Startup

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Misc"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub Startup1_Tick_wires()
        ' wire Wire21 is sendto wire
        call LootCarrier1.Drop()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Startup1_Tick_wires

    public sub RangeTest1_InRange_wires()
        select case mWireColor
        case 1
            ' wire Wire26 is a copy wire
            call Steering1.setAngle(RangeTest1.Input)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'RangeTest1_InRange_wires

    public sub RangeTest1_AboveRange_wires()
        ' wire Wire25 is a copy wire
        call Variable3.setInput(RangeTest1.Maximum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_AboveRange_wires

    public sub RangeTest1_BelowRange_wires()
        ' wire Wire24 is a copy wire
        call Variable3.setInput(RangeTest1.Minimum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_BelowRange_wires

    public sub Variable3_Change_wires()
        ' wire Wire22 is a copy wire
        call RangeTest1.setInput(Variable3.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable3_Change_wires

    public sub Variable1_Change_wires()
        ' wire Wire9 is sendto wire
        call TickTimer2.setRate(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub Variable1_Querying_wires()
        ' wire Wire4 is a copy wire
        call Variable3.setIncrementBy(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Querying_wires

    public sub TickTimer2_Tick_wires()
        ' wire Wire3 is sendto wire
        call Variable1.Query()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'TickTimer2_Tick_wires

    public sub LongRangeRadar1_TurnOn_wires()
        ' wire Wire8 is sendto wire
        call Variable1.setInput(-7)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire1 is sendto wire
        call Variable3.setInput(-1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_TurnOn_wires

    public sub LongRangeRadar1_TurnOff_wires()
        ' wire Wire7 is sendto wire
        call Variable1.setInput(7)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire2 is sendto wire
        call Variable3.setInput(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_TurnOff_wires

    public sub ModeSwitch1_Leave_wires()
        select case mWireColor
        case 2
            ' wire Wire23 is sendto wire
            call Steering1.setAngle(15)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'ModeSwitch1_Leave_wires

    public sub Compare1_EqualTo_wires()
        ' wire Wire20 is sendto wire
        call Variable2.setInput(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_EqualTo_wires

    public sub LongRangeRadar1_Change_wires()
        ' wire Wire18 is sendto wire
        call Variable2.setIncrementBy(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_Change_wires

    public sub TickTimer1_Tick_wires()
        ' wire Wire17 is sendto wire
        call Variable2.Query()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'TickTimer1_Tick_wires

    public sub Variable2_Change_wires()
        ' wire Wire16 is sendto wire
        call TickTimer1.setRate(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire19 is a copy wire
        call Compare1.setInput1(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable2_Change_wires

    public sub Variable2_Querying_wires()
        ' wire Wire15 is a copy wire
        call WaypointSensor1.setCurrentWaypoint(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable2_Querying_wires

    public sub WaypointSensor1_Change_wires()
        ' wire Wire13 is a copy wire
        call Add1.setInput1(WaypointSensor1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire14 is a copy wire
        call Variable2.setInput(WaypointSensor1.CurrentWaypoint)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'WaypointSensor1_Change_wires

    public sub Add1_Change_wires()
        ' wire Wire12 is a copy wire
        call WrapVar1.setInput(Add1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Add1_Change_wires

    public sub WrapVar1_Change_wires()
        ' wire Wire10 is a copy wire
        call Divide1.setInput1(WrapVar1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'WrapVar1_Change_wires

    public sub LootCarrier1_TurnOff_wires()
        ' wire Wire6 is sendto wire
        call ModeSwitch1.setMode(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LootCarrier1_TurnOff_wires

    public sub LootCarrier1_TurnOn_wires()
        ' wire Wire5 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LootCarrier1_TurnOn_wires

    public sub Divide1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire11 is a copy wire
            call Steering1.setAngle(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Divide1_Change_wires

    public function getChassisName() as string
        getChassisName = "WheelS"
    end function

    public function getDescription() as string
        getDescription = "Created by DavidW||for Hotpotato||similar to SteveT's HotPotXIV ||also uses Tex's avoidance tactic [the dominant feature of this bot!]||uses LR radar & operates in reverse to maximize usable radar width||accelerated tracking sytem|||||||"
    end function

    public function specifyComponents() as string
        specifyComponents = "WheelS LargeEngine Steering LootCarrier LongRangeRadar WaypointSensor Divide ModeSwitch WrapVar Add TickTimer Variable Compare Variable Variable TickTimer RangeTest Startup"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("BigE_MK3")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle BigE_MK3 can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize LargeEngine1
        LargeEngine1 = sys.getComponent("LargeEngine")
        if LargeEngine1 = null then
           call sys.printToLog("BigE_MK3: LargeEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LargeEngine1, "LargeEngine", "LargeEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LargeEngine1, -0.0837702, 0.025, 0) then
            call sys.printToLog("BigE_MK3: LargeEngine1 not placed")
            exit function
        end if
        call LargeEngine1.setThrottle(-100)

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("BigE_MK3: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, -0.0587702, -0.05, 0) then
            call sys.printToLog("BigE_MK3: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(15)

        ' initialize LootCarrier1
        LootCarrier1 = sys.getComponent("LootCarrier")
        if LootCarrier1 = null then
           call sys.printToLog("BigE_MK3: LootCarrier1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LootCarrier1, "LootCarrier", "LootCarrier1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LootCarrier1, -0.00877024, 0, 0) then
            call sys.printToLog("BigE_MK3: LootCarrier1 not placed")
            exit function
        end if

        ' initialize LongRangeRadar1
        LongRangeRadar1 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar1 = null then
           call sys.printToLog("BigE_MK3: LongRangeRadar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar1, "LongRangeRadar", "LongRangeRadar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar1, 0.0412298, 0, 0) then
            call sys.printToLog("BigE_MK3: LongRangeRadar1 not placed")
            exit function
        end if
        call LongRangeRadar1.setMaxRange(7)
        call LongRangeRadar1.setAngle(-165)
        call LongRangeRadar1.setScanWidth(30)

        ' initialize WaypointSensor1
        WaypointSensor1 = sys.getComponent("WaypointSensor")
        if WaypointSensor1 = null then
           call sys.printToLog("BigE_MK3: WaypointSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(WaypointSensor1, "WaypointSensor", "WaypointSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(WaypointSensor1, -0.10877, -0.05, 0) then
            call sys.printToLog("BigE_MK3: WaypointSensor1 not placed")
            exit function
        end if
        call WaypointSensor1.setCurrentWaypoint(1)
        call WaypointSensor1.setWaypointList("abcd")

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("BigE_MK3: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(0)
        call Divide1.setInput2(-4)
        call Divide1.setCalc(1)

        ' initialize ModeSwitch1
        ModeSwitch1 = sys.getComponent("ModeSwitch")
        if ModeSwitch1 = null then
           call sys.printToLog("BigE_MK3: ModeSwitch1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(ModeSwitch1, "ModeSwitch", "ModeSwitch1")
        end if
        ' Logical component doesn't need to be positioned
        call ModeSwitch1.setMode(0)

        ' initialize WrapVar1
        WrapVar1 = sys.getComponent("WrapVar")
        if WrapVar1 = null then
           call sys.printToLog("BigE_MK3: WrapVar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(WrapVar1, "WrapVar", "WrapVar1")
        end if
        ' Logical component doesn't need to be positioned
        call WrapVar1.setInput(0)
        call WrapVar1.setMin(-180)
        call WrapVar1.setMax(180)

        ' initialize Add1
        Add1 = sys.getComponent("Add")
        if Add1 = null then
           call sys.printToLog("BigE_MK3: Add1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Add1, "Add", "Add1")
        end if
        ' Logical component doesn't need to be positioned
        call Add1.setInput1(0)
        call Add1.setInput2(180)

        ' initialize TickTimer1
        TickTimer1 = sys.getComponent("TickTimer")
        if TickTimer1 = null then
           call sys.printToLog("BigE_MK3: TickTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(TickTimer1, "TickTimer", "TickTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call TickTimer1.setRate(0)

        ' initialize Variable2
        Variable2 = sys.getComponent("Variable")
        if Variable2 = null then
           call sys.printToLog("BigE_MK3: Variable2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable2, "Variable", "Variable2")
        end if
        ' Logical component doesn't need to be positioned
        call Variable2.setInput(0)

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("BigE_MK3: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(5)
        call Compare1.setCalc(1)

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("BigE_MK3: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(0)

        ' initialize Variable3
        Variable3 = sys.getComponent("Variable")
        if Variable3 = null then
           call sys.printToLog("BigE_MK3: Variable3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable3, "Variable", "Variable3")
        end if
        ' Logical component doesn't need to be positioned
        call Variable3.setInput(0)

        ' initialize TickTimer2
        TickTimer2 = sys.getComponent("TickTimer")
        if TickTimer2 = null then
           call sys.printToLog("BigE_MK3: TickTimer2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(TickTimer2, "TickTimer", "TickTimer2")
        end if
        ' Logical component doesn't need to be positioned
        call TickTimer2.setRate(1)

        ' initialize RangeTest1
        RangeTest1 = sys.getComponent("RangeTest")
        if RangeTest1 = null then
           call sys.printToLog("BigE_MK3: RangeTest1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest1, "RangeTest", "RangeTest1")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest1.setMaximum(15)
        call RangeTest1.setMinimum(-15)
        call RangeTest1.setInput(0)

        ' initialize Startup1
        Startup1 = sys.getComponent("Startup")
        if Startup1 = null then
           call sys.printToLog("BigE_MK3: Startup1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Startup1, "Startup", "Startup1")
        end if
        ' Logical component doesn't need to be positioned

        call Startup1.Tick.register(Startup1_Tick_wires)
        call RangeTest1.InRange.register(RangeTest1_InRange_wires)
        call RangeTest1.AboveRange.register(RangeTest1_AboveRange_wires)
        call RangeTest1.BelowRange.register(RangeTest1_BelowRange_wires)
        call Variable3.Change.register(Variable3_Change_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call Variable1.Querying.register(Variable1_Querying_wires)
        call TickTimer2.Tick.register(TickTimer2_Tick_wires)
        call LongRangeRadar1.TurnOn.register(LongRangeRadar1_TurnOn_wires)
        call LongRangeRadar1.TurnOff.register(LongRangeRadar1_TurnOff_wires)
        call ModeSwitch1.Leave.register(ModeSwitch1_Leave_wires)
        call Compare1.EqualTo.register(Compare1_EqualTo_wires)
        call LongRangeRadar1.Change.register(LongRangeRadar1_Change_wires)
        call TickTimer1.Tick.register(TickTimer1_Tick_wires)
        call Variable2.Change.register(Variable2_Change_wires)
        call Variable2.Querying.register(Variable2_Querying_wires)
        call WaypointSensor1.Change.register(WaypointSensor1_Change_wires)
        call Add1.Change.register(Add1_Change_wires)
        call WrapVar1.Change.register(WrapVar1_Change_wires)
        call LootCarrier1.TurnOff.register(LootCarrier1_TurnOff_wires)
        call LootCarrier1.TurnOn.register(LootCarrier1_TurnOn_wires)
        call Divide1.Change.register(Divide1_Change_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'BigE_MK3
' END TEMPLATE
